// DO NOT USE THIS FILE IN FINAL APP, this header is only for demo usage.
// This header is based on FDFB DDI V0.99, is NOT compatible with 0.95

#ifndef _CSC_H_
#define _CSC_H_

#include <d3d11.h>
#include <d3d11_1.h>
#include <atlcomcli.h>
#include "../config.h"

class CscFilter
{

public:
    CscFilter() { m_bInited = FALSE; };
    HRESULT Init(FOURCC eFourccOut, FOURCC eFourccIn, INT iWidth, INT iHeight);
    HRESULT Destroy();
    HRESULT Blt(BYTE *pBufOut, BYTE *pBufIn, INT iWidth, INT iHeight);

    BOOL m_bInited;

#if TARGET_PLATFORM_WIN10
    HRESULT SetHorizontalMirrorGpu(BOOL bEnable);
#endif

private:
    CCritSec m_MutexLock;
    FOURCC   m_eFourccIn = 0;
    FOURCC   m_eFourccOut = 0;
    INT      m_iWidth = 0;
    INT      m_iHeight = 0;

    // smart pointer for auto release these resource
    CComPtr<ID3D11Device>                   m_pD3d11Device;
    CComPtr<ID3D11DeviceContext1>           m_pD3d11DeviceContext;
    CComPtr<ID3D11VideoDevice>              m_pD3d11VideoDevice;
    CComPtr<ID3D11VideoProcessorEnumerator> m_pD3d11VideoProcessorEnum;

#if TARGET_PLATFORM_WIN10
    CComPtr<ID3D11VideoContext1>            m_pD3d11VideoContext;
#else
    CComPtr<ID3D11VideoContext>             m_pD3d11VideoContext;
#endif
    CComPtr<ID3D11VideoProcessor>           m_pD3d11VideoProcessor;

    CComPtr<ID3D11Texture2D>                m_pTextureStagingIn;
    CComPtr<ID3D11Texture2D>                m_pTextureStagingOut;
    CComPtr<ID3D11Texture2D>                m_pTextureIn;
    CComPtr<ID3D11VideoProcessorInputView>  m_pViewIn;
    CComPtr<ID3D11Texture2D>                m_pTextureOut;
    CComPtr<ID3D11VideoProcessorOutputView> m_pViewOut;

    HRESULT CreateDevice();
    HRESULT CreateVideoProcessor(INT iWidth, INT iHeight);

    HRESULT CreateStagingTexture(CComPtr<ID3D11Texture2D> &TextureStaging, INT iWidth, INT iHeight, FOURCC eFourcc);
    HRESULT CreateInputFrame(CComPtr<ID3D11Texture2D> &pTextureIn, CComPtr<ID3D11VideoProcessorInputView> &pViewIn, INT iWidth, INT iHeight, FOURCC eFourcc);
    HRESULT CreateOutputFrame(CComPtr<ID3D11Texture2D> &pTextureOut, CComPtr<ID3D11VideoProcessorOutputView> &pViewOut, INT iWidth, INT iHeight, FOURCC eFourcc);

    HRESULT CopyBufToTextureStaging(ID3D11Texture2D *pTextureStaging, BYTE *pBufIn, INT iWidth, INT iHeight, FOURCC eFourccIn);
    HRESULT CopyTextureStagingToBuf(BYTE *pBufNv12Out, ID3D11Texture2D *pTextureStaging, INT iWidth, INT iHeight, FOURCC eFourccOut);
    HRESULT VideoProcessorBlt(CComPtr<ID3D11VideoProcessorOutputView> pViewOut, CComPtr<ID3D11VideoProcessorInputView> pViewIn);

};

#endif