#include <mmiscapi.h>
#include "common_utils.h"
#include "mfxjpeg.h"


#define MFX_OK(sts) (sts >= MFX_ERR_NONE)
#define MFX_FAIL(sts) (sts < MFX_ERR_NONE)
#define DECODED_BUF_SIZE_MAX (1920*1080*3/2)


class MjpgDecoder
{

public:
    HRESULT Init(FOURCC eFourccOut, INT iWidth, INT iHeight);
    HRESULT Decode(BYTE *pMjpgBitStreamIn, INT iMjpgBitStreamLenIn, BYTE *byteBufOut);
    HRESULT Destroy();

    INT              m_iWidth;
    INT              m_iHeight;

private:
    BYTE             m_pMjpgDecoded[DECODED_BUF_SIZE_MAX];
    MFXVideoSession  m_session;
    mfxVideoParam    m_mfxVideoParams;
    mfxFrameSurface1 m_MfxSurface;
    MFXVideoDECODE   *m_pMfxDEC;
    BOOL             m_bMfxVideoDecodeInited; // used to check if MFXVideoDECODE->Init() has been called.

    HRESULT GetMfxBitStream(mfxBitstream *pMfxBsOut, BYTE *pMjpgBufIn, INT iMjpgBufLen);
    HRESULT GetMfxVideoParamsMjpeg(mfxVideoParam *pMfxVp);
    HRESULT AllocateMfxSurfaceMjpeg(INT iWidth, INT iHeight);
    HRESULT SetMfxSurfaceMjpeg(mfxFrameInfo FrameInfo);
};