// DO NOT USE THIS FILE IN FINAL APP, this header is only for demo usage.
// This header is based on FDFB DDI V0.99, is NOT compatible with 0.95

#ifndef _FDFB_H_
#define _FDFB_H_

#include <vector>
#include <windows.h>
#include <d3d11.h>
#include <fstream>
#include <sstream>
#include <atlcomcli.h>
#include "../utils_mft.h"
using namespace ATL;

static GUID DX11_VPREP_OPERATION_GUID_2_6 = { 0xEDD1D4B9, 0x8659, 0x4CBC, { 0xA4, 0xD6, 0x98, 0x31, 0xA2, 0x16, 0x3A, 0xC3 } };

#define FDFB_FACE_COUNT_MAX 8 // for FDFB DDI V0.99 we support up to 8 faces
#define FDFB_FACE_COUNT_DEFAULT 4
#define FDFB_SUPPORTED_MAXIMUM_WIDTH 1920
#define FDFB_SUPPORTED_MAXIMUM_HEIGHT 1088
#define FDFB_OUTPUT_BUF_SIZE FDFB_SUPPORTED_MAXIMUM_WIDTH * FDFB_SUPPORTED_MAXIMUM_HEIGHT * 3

typedef enum _VPE_FDFB_CAPS_ENUM
{
    VPE_FDFB_CAPS_FLAG = 0,
    VPE_FDFB_CAPS_FD_MIN_FACE_SIZE = 1,
    VPE_FDFB_CAPS_FD_MAX_FACE_COUNT = 2,
    VPE_FDFB_CAPS_FB_MAX_FACE_COUNT = 3,
    VPE_FDFB_CAPS_FD_MAX_STEP = 4,
    VPE_FDFB_CAPS_MAX_MULTIVIEW = 5,
    VPE_FDFB_CAPS_FD_INPUT_FORMAT = 6,
    VPE_FDFB_CAPS_FB_INPUT_FORMAT = 7,
    VPE_FDFB_CAPS_FB_OUTPUT_FORMAT = 8,
    VPE_FDFB_CAPS_MAX_IMAGE_SIZE = 9,
    VPE_FDFB_CAPS_FD_MULTIVIEW = 10,
    VPE_FDFB_CAPS_FB_MULTIVIEW = 11,
    VPE_FDFB_CAPS_FB_MIN_FACE_SIZE_RATIO = 12,
    VPE_FDFB_CAPS_FD_FACE_SELECTION_CRITERIA = 13,
    VPE_FDFB_CAPS_FB_FEATURE_SUPPORT = 100,
    VPE_FDFB_CAPS_FB_FEATURE_STRENGTH_UNIFY_RANGE_MIN = 101,
    VPE_FDFB_CAPS_FB_FEATURE_STRENGTH_UNIFY_RANGE_MAX = 102,
    VPE_FDFB_CAPS_FB_FEATURE_COLOR_YUV_UNIFY_RANGE_MIN = 103,
    VPE_FDFB_CAPS_FB_FEATURE_COLOR_YUV_UNIFY_RANGE_MAX = 104,
    VPE_FDFB_CAPS_FB_RED_LIP_STRENGTH_DEFAULT = 105,
    VPE_FDFB_CAPS_FB_BIG_EYE_STRENGTH_DEFAULT = 106,
    VPE_FDFB_CAPS_FB_SLIM_FACE_STRENGTH_DEFAULT = 107,
    VPE_FDFB_CAPS_FB_HAPPY_FACE_STRENGTH_DEFAULT = 108,
    VPE_FDFB_CAPS_FB_CUTE_NOSE_STRENGTH_DEFAULT = 109,
    VPE_FDFB_CAPS_FB_SKIN_RESERVED1_STRENGTH_DEFAULT = 110,
    VPE_FDFB_CAPS_FB_SKIN_RESERVED2_STRENGTH_DEFAULT = 111,
    VPE_FDFB_CAPS_FB_SKIN_FOUNDATION_STRENGTH_DEFAULT = 112,
    VPE_FDFB_CAPS_FB_SKIN_FOUNDATION_COLOR_DEFAULT = 113,
    VPE_FDFB_CAPS_FB_SKIN_SMOOTHING_STRENGTH_DEFAULT = 114,
    VPE_FDFB_CAPS_FB_CIRCLES_REMOVAL_STRENGTH_DEFAULT = 115,
    VPE_FDFB_CAPS_FB_EYE_BAGS_REMOVAL_STRENGTH_DEFAULT = 116,
    VPE_FDFB_CAPS_FB_EYE_WRINKLES_REMOVAL_STRENGTH_DEFAULT = 117,
    VPE_FDFB_CAPS_FB_BLUSH_STRENGTH_DEFAULT = 118,

    VPE_FDFB_CAPS_END
} VPE_FDFB_CAPS_ENUM;

typedef struct _VPE_FDFB_CAPS_PARAM
{
    VPE_FDFB_CAPS_ENUM nParamName;
    UINT nDataSize; // actual size in BYTE for following Data member
    union {
        UINT nValue;
        BYTE Data[8];
    };
} VPE_FDFB_CAPS_PARAM;

typedef enum _VPE_FACE_VIEWS
{
    VPE_FACE_VIEW_FRONTAL = 0,
    VPE_FACE_VIEW_NEAR_FRONTAL = 1,
    VPE_FACE_VIEW_HALF_MVIEW = 2,
    VPE_FACE_VIEW_HALF_OMNI = 3,
    VPE_FACE_VIEW_HALF_OMNI_MVIEW = 4,
    VPE_FACE_VIEW_FULL_OMNI_MVIEW = 5,
    VPE_FACE_VIEW_END
} VPE_FACE_VIEWS_ENUM;

typedef enum VPE_FD_FACE_SELECTION_CRITERIA
{
    VPE_FD_FACE_SORT_BY_MAX_SIZE = 0,
    VPE_FD_FACE_SORT_BY_CENTER = 1,
    VPE_FD_FACE_SORT_CRITERIA_END
} VPE_FD_FACE_SELECTION_CRITERIA_ENUM;

typedef struct _VPE_FB_FEATURE_SURPORT
{
    // DWORD 0
    UINT  bRED_LIP_STRENGTH : 1;
    UINT  bBIG_EYE_STRENGTH : 1;
    UINT  bSLIM_FACE_STRENGTH : 1;
    UINT  bHAPPY_FACE_STRENGTH : 1;
    UINT  bCUTE_NOSE_STRENGTH : 1;
    UINT  bSKIN_RESERVED1_STRENGTH : 1;
    UINT  bSKIN_RESERVED2_STRENGTH : 1;
    UINT  bSKIN_FOUNDATION_STRENGTH : 1;
    UINT  bSKIN_FOUNDATION_COLOR : 1;
    UINT  bSKIN_SMOOTHING_STRENGTH : 1;
    UINT  bCIRCLES_REMOVAL_STRENGTH : 1;
    UINT  bEYE_BAGS_REMOVAL_STRENGTH : 1;
    UINT  bEYE_WRINKLES_REMOVAL_STRENGTH : 1;
    UINT  bBLUSH_STRENGTH : 1;
    UINT  Reserved : 18;

    // DWORD 1
    UINT Reserved2 : 32;
} VPE_FB_FEATURE_SURPORT;


#define VPE_FDFB_CAPS_FLAG_INTERLACE    0x1  // support interlaced input
#define VPE_FDFB_CAPS_FLAG_FDONLY       0x2  // support face detection only processing
#define VPE_FDFB_CAPS_FLAG_FBONLY       0x4  // support face beautification only processing
#define VPE_FDFB_CAPS_FLAG_VPPROCESSING 0x8  // support rescaling in FD/FB path
#define VPE_FDFB_CAPS_CONFIDENCE_LEVEL  0x10 // provide confidence level in face detection
#define VPE_FDFB_CAPS_RESERVED          0x20 // Reserved for future usage
#define VPE_FDFB_CAPS_STATIC_IMAGE      0x40 // provide static image support
#define VPE_FDFB_CAPS_FEATURE_EXT1      0x80 // flag for extended FDFB features. 

typedef enum _VPE_FDFB_PARAM_ENUM
{
    VPE_FDP_MODE = 0,
    VPE_FDP_INIT_STREAM_MODE,
    VPE_FDP_INIT_MIN_SIZE,
    VPE_FDP_INIT_MAX_FACE_COUNT,
    VPE_FDP_INIT_STEP_SIZE,
    VPE_FDP_INIT_MULTIVIEW,
    VPE_FDP_INIT_FACE_SELECTION_CRITERIA,
    VPE_FDP_INIT_END,
    VPE_FDP_INIT_REGION_END = 0x800,
    VPE_FDFB_MODE,
    VPE_FDP_FACE_COUNT,
    VPE_FDP_FACE_LIST,
    VPE_FDP_PARAM_END,
    VPE_FBP_SIZE = 0x1000,
    VPE_FBP_MAX_FACE_COUNT,
    VPE_FBP_FEATURE_STATE = 0x1010,
    VPE_FBP_RED_LIP_STRENGTH = 0x1020,
    VPE_FBP_BIG_EYE_STRENGTH = 0x1030,
    VPE_FBP_SLIM_FACE_STRENGTH = 0x1040,
    VPE_FBP_HAPPY_FACE_STRENGTH = 0x1050,
    VPE_FBP_CUTE_NOSE_STRENGTH = 0x1060,
    VPE_FBP_SKIN_RESERVED1_STRENGTH = 0x1070,
    VPE_FBP_SKIN_RESERVED2_STRENGTH = 0x1080,
    VPE_FBP_SKIN_FOUNDATION_STRENGTH = 0x1090,
    VPE_FBP_SKIN_FOUNDATION_COLOR = 0x1091,
    VPE_FBP_SKIN_SMOOTHING_STRENGTH = 0x10A0,
    VPE_FBP_CIRCLES_REMOVAL_STRENGTH = 0x10B0,
    VPE_FBP_EYE_BAGS_REMOVAL_STRENGTH = 0x10C0,
    VPE_FBP_EYE_WRINKLES_REMOVAL_STRENGTH = 0x10D0,
    VPE_FBP_BLUSH_STRENGTH = 0x10E0,
    VPE_FBP_PARAM_END,
    VPE_FDFB_VPPROCESSING_ENABLE = 0x4000,
    VPE_FDFB_VPPROCESSING_END
} VPE_FDFB_PARAM_ENUM;

typedef struct _VPE_FBP_FEATURE_ACTIVE
{
    UINT    bFB_RED_LIP_STRENGTH_Active : 1;
    UINT    bFB_BIG_EYE_STRENGTH_Active : 1;
    UINT    bFB_SLIM_FACE_STRENGTH_Active : 1;
    UINT    bFB_HAPPY_FACE_STRENGTH_Active : 1;
    UINT    bFB_CUTE_NOSE_STRENGTH_Active : 1;
    UINT    bFB_SKIN_RESERVED1_STRENGTH_Active : 1;
    UINT    bFB_SKIN_RESERVED2_STRENGTH_Active : 1;
    UINT    bFB_SKIN_FOUNDATION_STRENGTH_Active : 1;
    UINT    bFB_SKIN_FOUNDATION_Color_Active : 1;
    UINT    bFB_SKIN_SMOOTHING_STRENGTH_Active : 1;
    UINT    bFB_CIRCLES_REMOVAL_STRENGTH_Active : 1;
    UINT    bFB_EYE_BAGS_REMOVAL_STRENGTH_Active : 1;
    UINT    bFB_EYE_WRINKLES_REMOVAL_STRENGTH_Active : 1;
    UINT    bFB_BLUSH_STRENGTH_Active : 1;
    UINT    Reserved : 18;
    UINT    Reserved2 : 32;
} VPE_FBP_FEATURE_ACTIVE;

typedef struct _VPE_FDFB_PARAM
{
    VPE_FDFB_PARAM_ENUM nParamName;
    UINT  nDataSize; // actual size in BYTE for following Data member
    union {
        UINT nValue;
        BYTE Data[4];
        VPE_FBP_FEATURE_ACTIVE FbFeatureActive;
    };
} VPE_FDFB_PARAM;

typedef enum _VPE_FDP_MODE
{
    VPE_FDP_MODE_EXEC = 0,
    VPE_FDP_MODE_CONFIG = 1
} VPE_FDP_MODE_ENUM;

typedef enum _VPE_FDP_STREAM_MODE
{
    VPE_FDP_STREAM_MODE_VIDEO = 0,
    VPE_FDP_STREAM_MODE_IMAGE = 1
} VPE_FDP_STREAM_MODE_ENUM;

typedef enum _VPE_FDFB_MODE
{
    VPE_FDFB_MODE_FDFB      = 0, //  Full Pipe FDFB Mode
    VPE_FDFB_MODE_FDFB_EXT  = 1, // Reserved for future use
    VPE_FDFB_MODE_FD_ONLY   = 2, // only do face detection
    VPE_FDFB_MODE_FB_ONLY   = 3, // application provide face detection data
    VPE_FDFB_MODE_COUNT
} VPE_FDFB_MODE_ENUM;

typedef struct tagVPE_FACE_RECT
{
    // picture size
    RECT	face;
    UINT	confidence_level : 8;
    UINT	reserved0 : 24;
    UINT	orientation : 8;
    UINT	reserved1 : 24;
    UINT	reserved2[4];
} VPE_FACE_RECT;

typedef enum _VPE_FACE_ORIENTATIONS
{
    VPE_FACE_ORIENTATION_ROP00_RIP00 = 0,
    VPE_FACE_ORIENTATION_ROP00RIP30L = 1,
    VPE_FACE_ORIENTATION_ROP00RIP30R = 2,
    VPE_FACE_ORIENTATION_ROP00RIP60L = 3,
    VPE_FACE_ORIENTATION_ROP00RIP60R = 4,
    VPE_FACE_ORIENTATION_ROP90LRIP00 = 5,
    VPE_FACE_ORIENTATION_ROP90RRIP00 = 6,
    VPE_FACE_ORIENTATION_ROP90RIP30L = 7,
    VPE_FACE_ORIENTATION_ROP90RIP30R = 8,
    VPE_FACE_ORIENTATION_ROP00RIP90L = 9,
    VPE_FACE_ORIENTATION_ROP00RIP90R = 10,
    VPE_FACE_ORIENTATION_ROP90LRIP90L = 11,
    VPE_FACE_ORIENTATION_ROP90RRIP90R = 12,
    VPE_FACE_ORIENTATION_END
} VPE_FACE_ORIENTATIONS_ENUM;

enum TD3D11_VPREP_FUNCTION
{
    VPE_FN_SET_VERSION_PARAM = 0x1,
    VPE_FN_SET_STATUS_PARAM = 0x5,
    VPE_FN_GET_STATUS_PARAM = 0x6,
    VPE_FN_PROC_QUERY_CAPS = 0x10,
    VPE_FN_MODE_PARAM = 0x20,
    VPE_FN_CPU_GPU_COPY_QUERY_CAPS = 0x2A,
    VPE_FN_SET_CPU_GPU_COPY_PARAM = 0x2B,
    VPE_FN_VPREP_QUERY_CAPS = 0x30,
    VPE_FN_VPREP_ISTAB_PARAM = 0x31,
    VPE_FN_VPREP_INTERLACE_PARAM = 0x32,
    VPE_FN_VPREP_QUERY_VARIANCE_CAPS = 0x33,
    VPE_FN_VPREP_SET_VARIANCE_PARAM = 0x34,
    VPE_FN_VPREP_GET_VARIANCE_PARAM = 0x35,
    VPE_FN_VPREP_YUV_RANGE_PARAM = 0x36,
    VPE_FN_FDFB_QUERY_CAPS = 0x200,
    VPE_FN_FDFB_PARAM = 0x201,
};

enum VPE_MODE
{
    VPE_MODE_NONE = 0,
    VPE_MODE_PREPROC,
    VPE_MODE_CAM_PIPE,
    VPE_MODE_CPU_GPU_COPY,
    VPE_MODE_FDFB,
};

struct VPE_VERSION
{
    UINT Version;
};

struct VPE_MODE_PARAM
{
    VPE_MODE	Mode;
};

struct VPE_SET_STATUS_PARAM
{
    UINT		bEnableStatusCollection : 1;
    UINT		Reserved : 31;
};

enum VPE_STATUS
{
    VPE_STATUS_COMPLETED = 0,
    VPE_STATUS_NOT_READY,
    VPE_STATUS_NOT_AVAILABLE
};

struct VPE_STATUS_PARAM
{
    UINT		FrameId;
    VPE_STATUS	Status;
};

struct VPE_GET_STATUS_PARAMS
{
    UINT					StatusCount;
    VPE_STATUS_PARAM		*pStatusBuffer;
};

struct VPE_FUNCTION
{
    UINT								Function : 16; // [IN]
    union
    {
        VPE_VERSION						*pVersion;
        VPE_MODE_PARAM					*pModeParam;
        VPE_SET_STATUS_PARAM			*pSetStatusParam;
        VPE_GET_STATUS_PARAMS			*pGetStatusParams;
        //VPE_PROC_QUERY_CAPS				*pProcCaps;
        //VPE_CPU_GPU_COPY_QUERY_CAPS		*pCpuGpuCopyCaps;
        //VPE_CPU_GPU_COPY_PARAM			*pCpuGpuCopyParam;
        //VPE_VPREP_CAPS					*pVprepCaps;
        //VPE_VPREP_ISTAB_PARAM			*pIStabParam;
        //VPE_VPREP_INTERLACE_PARAM		*pInterlaceParam;
        //VPE_VPREP_VARIANCE_CAPS			*pVarianceCaps;
        //VPE_VPREP_SET_VARIANCE_PARAM	*pSetVarianceParam;
        //VPE_VPREP_GET_VARIANCE_PARAMS	*pGetVarianceParams;
        //VPE_VPREP_YUV_RANGE_PARAM		*pYUVRangeParam;
        //VPE_VPREP_SCALING_MODE_PARAM    *pScalingModePraram;
        VPE_FDFB_PARAM                  *pFDFBParam;

    };
};

enum PREPROC_OP_STATUS
{
    VPREP_STATUS_OK = 0,
    VPREP_STATUS_NOT_READY = 1,
    VPREP_STATUS_NOT_AVAILABLE = 2,
    VPREP_STATUS_ERROR = 3
};


#define FDFB_FEATURE_NUM_MAX 14
#define FDFB_FEATURE_VALUE_MAX 100
#define FDFB_FEATURE_VALUE_MIN 0
#define FDFB_FEATURE_KEYNAME_SIZE 56
#define FDFB_COLOR_VALUE_MAX 255
#define FDFB_COLOR_VALUE_MIN 0

typedef struct _FDFB_FILTER_FEATURE_ENTRY
{
    BOOL blActive;
    VPE_FDFB_PARAM_ENUM eParam;
    UINT uiValue;
    CHAR szKeyName[FDFB_FEATURE_KEYNAME_SIZE];
} FDFB_FILTER_FEATURE_ENTRY;


typedef struct _FDFB_FILTER_FEATURE_LIST
{
    UINT uiNum = FDFB_FEATURE_NUM_MAX;
    FDFB_FILTER_FEATURE_ENTRY paEntry[FDFB_FEATURE_NUM_MAX]; 
} FDFB_FILTER_FEATURE_LIST;


HRESULT FeatureInit(FDFB_FILTER_FEATURE_LIST *pFeatureList);
HRESULT InitFeatureReg(FDFB_FILTER_FEATURE_LIST *pFeatureList);
HRESULT ReadFeatureReg(FDFB_FILTER_FEATURE_LIST *pFeatureList);


#define FDFB_INPUT_FORMAT  FOURCC_NV12
#define FDFB_OUTPUT_FORMAT FOURCC_NV12

class FdfbFilter
{

public:
    FdfbFilter();
    ~FdfbFilter();

    HRESULT Init(ID3D11Device *pD3d11Device, ID3D11DeviceContext *pD3d11DeviceContext, FOURCC eFourCcOut, FOURCC eFourCcIn, INT iWidth, INT iHeight);
    HRESULT Destroy();
    HRESULT Blt(BYTE *pFrameBufOut, BYTE *pFrameBufIn, INT iWidth, INT iHeight, BOOL blRegKeyHasBeenChanged);
    HRESULT BltText(ID3D11Texture2D *pTextIn, BOOL blRegKeyHasBeenChanged);
    ID3D11Texture2D* GetBltTextOut();

private:
    CONST GUID *m_pVprepOperationGUID    = &DX11_VPREP_OPERATION_GUID_2_6;
    CONST VPE_FDFB_MODE_ENUM m_cFDFBMode = VPE_FDFB_MODE_FDFB; //VPE_FDFB_MODE_FB_ONLY;

    FOURCC m_eFourCcIn;
    FOURCC m_eFourCcOut;

    CCritSec                                m_MutexLock;

    CComPtr<ID3D11Texture2D>                m_pTextureStagingIn;
    CComPtr<ID3D11Texture2D>                m_pTextureStagingOut;
    CComPtr<ID3D11Texture2D>                m_pTextureIn;
    CComPtr<ID3D11VideoProcessorInputView>  m_pViewIn;
    CComPtr<ID3D11Texture2D>                m_pTextOut;
    CComPtr<ID3D11VideoProcessorOutputView> m_pViewOut;

    // smart pointer for auto release these resource
    CComPtr<ID3D11Device>                   m_pD3d11Device;
    CComPtr<ID3D11DeviceContext>            m_pD3d11DeviceContext;
    CComPtr<ID3D11VideoDevice>              m_pD3d11VideoDevice;
    CComPtr<ID3D11VideoProcessorEnumerator> m_pD3d11VideoProcessorEnum;
    CComPtr<ID3D11VideoContext>             m_pD3d11VideoContext;
    CComPtr<ID3D11VideoProcessor>           m_pD3d11VideoProcessor;

    HRESULT CreateDevice();
    HRESULT CreateVideoProcessor(INT iWidth, INT iHeight);

    HRESULT CreateStagingTexture(CComPtr<ID3D11Texture2D> &TextureStaging, INT iWidth, INT iHeight, DXGI_FORMAT eFormat);
    HRESULT CreateInputFrame(CComPtr<ID3D11Texture2D> &pTextureIn, CComPtr<ID3D11VideoProcessorInputView> &pViewIn, INT iWidth, INT iHeight, DXGI_FORMAT eFormat, UINT FourCC);
    HRESULT CreateOutputFrame(CComPtr<ID3D11Texture2D> &pTextureOut, CComPtr<ID3D11VideoProcessorOutputView> &pViewOut, INT iWidth, INT iHeight, DXGI_FORMAT eFormat);

    HRESULT CopyBufToTextureStaging(ID3D11Texture2D *pTextureStaging, BYTE *pBufNv12In, INT iWidth, INT iHeight);
    HRESULT CopyTextureStagingToBuf(BYTE *pBufNv12Out, ID3D11Texture2D *pTextureStaging, INT iWidth, INT iHeight);

    HRESULT SetParams();
    HRESULT VideoProcessorBlt(CComPtr<ID3D11VideoProcessorOutputView> pOutputView, CComPtr<ID3D11VideoProcessorInputView> pInputView);
    HRESULT VideoProcessorWait();

    FDFB_FILTER_FEATURE_LIST m_FeatureList;
    HRESULT  SetFeatureParams();
};

#endif