// DO NOT USE THIS FILE IN FINAL APP, this header is only for demo usage.
// This header is based on FDFB DDI V0.99, is NOT compatible with 0.95

#ifndef _ROTATION_H_
#define _ROTATION_H_

#include <d3d11.h>
#include <atlcomcli.h>
#include <mmiscapi.h>
#include "../config.h"
#include "../utils_mft.h"


class RotationFilter
{

public:
    HRESULT Init(ID3D11Device *pD3d11Device, ID3D11DeviceContext *pD3d11DeviceContext, FOURCC eFourcc, INT iStreamW, INT iStreamH, INT iTargetW, INT iTargetH);
    HRESULT Destroy();

    HRESULT BltText(ID3D11Texture2D *pTextIn, D3D11_VIDEO_PROCESSOR_ROTATION eRotateAngle);
    HRESULT BltBuf(BYTE *pBufIn, UINT uiWidth, UINT uiHeight, D3D11_VIDEO_PROCESSOR_ROTATION eRotateAngle);

    ID3D11Texture2D* GetBltTextOut();
    HRESULT GetBltBufOut(BYTE *pBufOut, UINT uiBufSize);

private:
    CCritSec m_MutexLock;
    FOURCC   m_eFourccIn;
    FOURCC   m_eFourccOut;
    INT      m_iStreamW;
    INT      m_iStreamH;
    INT      m_iTargetW;
    INT      m_iTargetH;

    // smart pointer for auto release these resource
    CComPtr<ID3D11Device>                   m_pD3d11Device;
    CComPtr<ID3D11DeviceContext>            m_pD3d11DeviceContext;
    CComPtr<ID3D11VideoDevice>              m_pD3d11VideoDevice;
    CComPtr<ID3D11VideoProcessorEnumerator> m_pD3d11VideoProcessorEnum;
    CComPtr<ID3D11VideoContext>             m_pD3d11VideoContext;
    CComPtr<ID3D11VideoProcessor>           m_pD3d11VideoProcessor;

    CComPtr<ID3D11Texture2D>                m_pTextureStagingIn;
    CComPtr<ID3D11Texture2D>                m_pTextureStagingOut;
    CComPtr<ID3D11Texture2D>                m_pTextIn;
    CComPtr<ID3D11VideoProcessorInputView>  m_pViewIn;
    CComPtr<ID3D11Texture2D>                m_pTextOut;
    CComPtr<ID3D11VideoProcessorOutputView> m_pViewOut;

    HRESULT CreateDevice();
    HRESULT CreateVideoProcessor(INT iStreamW, INT iStreamH, INT iTargetW, INT iTargetH);

    HRESULT CreateStagingTexture(CComPtr<ID3D11Texture2D> &TextureStaging, INT iWidth, INT iHeight, FOURCC eFourcc);
    HRESULT CreateInputFrame(CComPtr<ID3D11Texture2D> &pTextureIn, CComPtr<ID3D11VideoProcessorInputView> &pViewIn, INT iWidth, INT iHeight, FOURCC eFourcc);
    HRESULT CreateOutputFrame(CComPtr<ID3D11Texture2D> &pTextureOut, CComPtr<ID3D11VideoProcessorOutputView> &pViewOut, INT iWidth, INT iHeight, FOURCC eFourcc);

    HRESULT CopyBufToTextureStaging(ID3D11Texture2D *pTextureStaging, BYTE *pBufIn, INT iWidth, INT iHeight, FOURCC eFourccIn);
    HRESULT CopyTextureStagingToBuf(BYTE *pBufNv12Out, ID3D11Texture2D *pTextureStaging, INT iWidth, INT iHeight, FOURCC eFourcc);
    HRESULT VideoProcessorBlt(CComPtr<ID3D11VideoProcessorOutputView> pViewOut, CComPtr<ID3D11VideoProcessorInputView> pViewIn);
    HRESULT SetStreamTargetRect(D3D11_VIDEO_PROCESSOR_ROTATION eRotateAngle);
};

#endif